#ifndef INC_XC_RENDER
#define INC_XC_RENDER

#include "UnRender.h"

extern XC_ENGINE_API void HookMeshes();
#define RENDER_API DLL_IMPORT


class RENDER_API FLightManagerBase
{
public:
	virtual void Init()=0;
	virtual void Exit()=0;
	virtual DWORD SetupForActor( FSceneNode* Frame, AActor* Actor, struct FVolActorLink* LeafLights, FActorLink* Volumetrics )=0;
	virtual void SetupForSurf( FSceneNode* Frame, FCoords& FacetCoords, FBspDrawList* Draw, FTextureInfo*& LightMap, FTextureInfo*& FogMap, UBOOL Merged )=0;
	virtual void FinishSurf()=0;
	virtual void FinishActor()=0;
	virtual FPlane Light( FTransSample& Point, DWORD ExtraFlags )=0;
	virtual FPlane Fog( FTransSample& Point, DWORD ExtraFlags )=0;
};
extern RENDER_API FLightManagerBase* GLightManager;


class UMesh_Hack : public UMesh
{
public:
	virtual void GetFrame( FVector* Verts, INT Size, FCoords Coords, AActor* Owner );
	virtual void Destroy(); //Deallocate caches
};

class ULodMesh_Hack : public ULodMesh
{
public:
	virtual void GetFrame( FVector* Verts, INT Size, FCoords Coords, AActor* Owner, INT& LODRequest );
	virtual void Destroy(); //Deallocate caches
};


#endif